#include <termios.h>
#include <fcntl.h>
#include <stdio.h>

#include <sys/types.h>
#include <signal.h>
#include <string.h>
#include <syslog.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
//#include <netinet/in.h>

//#include <sys/un.h>

#define cls fprintf(stderr,"\e[2J")
#define move(X,Y) fprintf(stderr,"\e[%i;%iH",Y,X)
#define ROWS 25
#define CURSOR(Y)  move(1,Y) /*     */

#define MAX_BUF 127

//#define SOK_FILE "/tmp/local"
#define PORT	1555

struct termios term;
tcflag_t oldflags;
int  cterm; // 

void mode();  /*    */
void reset(); /*    */

static char buf[MAX_BUF];
/*   */
static char _command_[MAX_BUF] = "-eo user,pid,ppid,c,pri,ni,sz,f,s,wchan,tty,cmd --sort user"; 
static int  k = 23; /*   */ 
static int sd;      /*   */
static int i,j,n;

void view(int sig)
{
 char c;
 CURSOR(2);

  write(sd,&k,sizeof k);
  write(sd,_command_,strlen(_command_)+1);
  
  fprintf(stderr,"\e[1m");
  
  for( i=0; i<k; )
  {
   n = read(sd,&c,1);
   if( n!=0)
   {
    if( c=='\n' )
    {
     if( i==0 ) fprintf(stderr,"\e[m");
     i++; fprintf(stderr,"\e[K");
    } 
    write(2,&c,1);
   }
  }
  fprintf(stderr,"\e[4J");
  alarm(2);
}

void dlg()
{
   int i, c, x=4, y=10;
   signal(SIGALRM,SIG_IGN);
   move(x-1,y  ); fprintf(stderr," Format ");
   move(x-1,y+1); fprintf(stderr,"                                                                          ");
   move(x-1,y+2); fprintf(stderr,"");
   move(x+1,y+1);
   fprintf(stderr,"%s",_command_);
   strcpy(buf,_command_);
   for(i=strlen(buf); (c=fgetc(stdin))!='\n';) 
   if( isprint(c) && i<72 ) buf[i]=c, fprintf(stderr,"%c",c), i++;
   /* BACKSPACE */
   else if( c==127 && i>0 ) move(x+i,y+1),fprintf(stderr," "), move(x+i,y+1), i--;
   else if( c=='\e' ) goto MENU_PS;
   buf[i]='\0';
   strcpy(_command_,buf);
   CURSOR(1);
   fprintf(stderr,"%s\e[K",_command_);
   MENU_PS:
   signal(SIGALRM,view);   view(SIGALRM);
}

main(int ac,char** av)
{
 int bs, s_len, i, j, c;
 struct sockaddr_in s_a;
 struct hostent* hp;

 if( !av[1] ) fprintf(stderr,"vps: Enter arg in command line\n");

 hp = gethostbyname(av[1]);
 if( !hp ) perror("vps"), exit(1);

 sd = socket(AF_INET,SOCK_STREAM,0); /*   */
 if( sd< 0 ){ fprintf(stderr,"ERROR: Can not open socket\n"); exit(1); }

 bzero(&s_a,sizeof s_a);
 bcopy(hp->h_addr,&s_a.sin_addr,hp->h_length);
 s_a.sin_family = AF_INET;
 s_a.sin_port = htons((u_short) PORT);
// strcpy(s_a.sun_path,SOK_FILE);
// s_len = sizeof s_a.sun_family + strlen(s_a.sun_path);

 if(connect(sd,(struct sockaddr*)&s_a,sizeof s_a)<0)
 { fprintf(stderr,"ERROR: Can not connect to server\n"); exit(2); }
 
 if( ac>1 )
 {
  _command_[0]='\0';
  for(i = 1; av[i]; i++) strcat(_command_,av[i]), strcat(_command_," ");
 } 

 mode(); /*    */

 cls;

 CURSOR(1);
 fprintf(stderr,"%s",_command_);

 
 signal(SIGALRM,view);

 view(SIGALRM);
 
 while( (c=fgetc(stdin))!='q' )
 {
  if( c=='a' ) dlg();
 }

 c = 0;
 write(sd,&c,sizeof c);
  
 close(sd);

 reset();
}

void mode()
{
    cterm = open("/dev/tty",O_RDWR);
    tcflush(cterm,TCIOFLUSH); //  
    tcgetattr(cterm,&term);  //  
    oldflags = term.c_lflag;	  //  
    //    ,
    //   SIGTTOU ( TOSTOP)
    //  SIGINT, SIGQUIT, SIGTSTP ( ISIG)
    term.c_lflag=term.c_lflag&(~ICANON)&(~ECHO)|TOSTOP|ISIG;
    tcsetattr(cterm,TCSANOW,&term); //  
}

void reset(){
    signal(SIGALRM,SIG_IGN);
    term.c_lflag=oldflags;
    tcsetattr(cterm,TCSANOW,&term); // 
    cls;
    move(1,1);
    exit(0);
}
